diff --git a/compiler/typecheck/TcArrows.lhs b/compiler/typecheck/TcArrows.lhs
index f530900..bddaf7e 100644
--- a/compiler/typecheck/TcArrows.lhs
+++ b/compiler/typecheck/TcArrows.lhs
@@ -5,16 +5,10 @@
 Typecheck arrow notation
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcArrows ( tcProc ) where
 
-import {-# SOURCE #-}	TcExpr( tcMonoExpr, tcInferRho, tcSyntaxOp, tcCheckId, tcPolyExpr )
+import {-# SOURCE #-}   TcExpr( tcMonoExpr, tcInferRho, tcSyntaxOp, tcCheckId, tcPolyExpr )
 
 import HsSyn
 import TcMatches
@@ -76,32 +70,32 @@ Note that
 
 
 %************************************************************************
-%*									*
-		Proc	
-%*									*
+%*                                                                      *
+                Proc    
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
-tcProc :: InPat Name -> LHsCmdTop Name		-- proc pat -> expr
-       -> TcRhoType				-- Expected type of whole proc expression
+tcProc :: InPat Name -> LHsCmdTop Name          -- proc pat -> expr
+       -> TcRhoType                             -- Expected type of whole proc expression
        -> TcM (OutPat TcId, LHsCmdTop TcId, TcCoercion)
 
 tcProc pat cmd exp_ty
   = newArrowScope $
-    do	{ (co, (exp_ty1, res_ty)) <- matchExpectedAppTy exp_ty 
-	; (co1, (arr_ty, arg_ty)) <- matchExpectedAppTy exp_ty1
-	; let cmd_env = CmdEnv { cmd_arr = arr_ty }
+    do  { (co, (exp_ty1, res_ty)) <- matchExpectedAppTy exp_ty 
+        ; (co1, (arr_ty, arg_ty)) <- matchExpectedAppTy exp_ty1
+        ; let cmd_env = CmdEnv { cmd_arr = arr_ty }
         ; (pat', cmd') <- tcPat ProcExpr pat arg_ty $
-			  tcCmdTop cmd_env cmd (unitTy, res_ty)
+                          tcCmdTop cmd_env cmd (unitTy, res_ty)
         ; let res_co = mkTcTransCo co (mkTcAppCo co1 (mkTcReflCo res_ty))
         ; return (pat', cmd', res_co) }
 \end{code}
 
 
 %************************************************************************
-%*									*
-		Commands
-%*									*
+%*                                                                      *
+                Commands
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -111,7 +105,7 @@ type CmdArgType = TcTauType                  -- carg_type, a nested tuple
 
 data CmdEnv
   = CmdEnv {
-	cmd_arr	:: TcType -- arrow type constructor, of kind *->*->*
+        cmd_arr :: TcType -- arrow type constructor, of kind *->*->*
     }
 
 mkCmdArrTy :: CmdEnv -> TcTauType -> TcTauType -> TcTauType
@@ -125,27 +119,27 @@ tcCmdTop :: CmdEnv
 
 tcCmdTop env (L loc (HsCmdTop cmd _ _ names)) cmd_ty@(cmd_stk, res_ty)
   = setSrcSpan loc $
-    do	{ cmd'   <- tcCmd env cmd cmd_ty
-	; names' <- mapM (tcSyntaxName ProcOrigin (cmd_arr env)) names
-	; return (L loc $ HsCmdTop cmd' cmd_stk res_ty names') }
+    do  { cmd'   <- tcCmd env cmd cmd_ty
+        ; names' <- mapM (tcSyntaxName ProcOrigin (cmd_arr env)) names
+        ; return (L loc $ HsCmdTop cmd' cmd_stk res_ty names') }
 ----------------------------------------
 tcCmd  :: CmdEnv -> LHsCmd Name -> CmdType -> TcM (LHsCmd TcId)
-	-- The main recursive function
+        -- The main recursive function
 tcCmd env (L loc cmd) res_ty
   = setSrcSpan loc $ do
-	{ cmd' <- tc_cmd env cmd res_ty
-	; return (L loc cmd') }
+        { cmd' <- tc_cmd env cmd res_ty
+        ; return (L loc cmd') }
 
 tc_cmd :: CmdEnv -> HsCmd Name  -> CmdType -> TcM (HsCmd TcId)
 tc_cmd env (HsCmdPar cmd) res_ty
-  = do	{ cmd' <- tcCmd env cmd res_ty
-	; return (HsCmdPar cmd') }
+  = do  { cmd' <- tcCmd env cmd res_ty
+        ; return (HsCmdPar cmd') }
 
 tc_cmd env (HsCmdLet binds (L body_loc body)) res_ty
-  = do	{ (binds', body') <- tcLocalBinds binds		$
-			     setSrcSpan body_loc 	$
-			     tc_cmd env body res_ty
-	; return (HsCmdLet binds' (L body_loc body')) }
+  = do  { (binds', body') <- tcLocalBinds binds         $
+                             setSrcSpan body_loc        $
+                             tc_cmd env body res_ty
+        ; return (HsCmdLet binds' (L body_loc body')) }
 
 tc_cmd env in_cmd@(HsCmdCase scrut matches) (stk, res_ty)
   = addErrCtxt (cmdCtxt in_cmd) $ do
@@ -165,25 +159,25 @@ tc_cmd env (HsCmdIf Nothing pred b1 b2) res_ty    -- Ordinary 'if'
     }
 
 tc_cmd env (HsCmdIf (Just fun) pred b1 b2) res_ty -- Rebindable syntax for if
-  = do 	{ pred_ty <- newFlexiTyVarTy openTypeKind
+  = do  { pred_ty <- newFlexiTyVarTy openTypeKind
         -- For arrows, need ifThenElse :: forall r. T -> r -> r -> r
         -- because we're going to apply it to the environment, not
         -- the return value.
         ; (_, [r_tv]) <- tcInstSkolTyVars [alphaTyVar]
-	; let r_ty = mkTyVarTy r_tv
+        ; let r_ty = mkTyVarTy r_tv
         ; let if_ty = mkFunTys [pred_ty, r_ty, r_ty] r_ty
         ; checkTc (not (r_tv `elemVarSet` tyVarsOfType pred_ty))
                   (ptext (sLit "Predicate type of `ifThenElse' depends on result type"))
-	; fun'  <- tcSyntaxOp IfOrigin fun if_ty
-  	; pred' <- tcMonoExpr pred pred_ty
-	; b1'   <- tcCmd env b1 res_ty
-	; b2'   <- tcCmd env b2 res_ty
+        ; fun'  <- tcSyntaxOp IfOrigin fun if_ty
+        ; pred' <- tcMonoExpr pred pred_ty
+        ; b1'   <- tcCmd env b1 res_ty
+        ; b2'   <- tcCmd env b2 res_ty
         ; return (HsCmdIf (Just fun') pred' b1' b2')
     }
 
 -------------------------------------------
--- 		Arrow application
---     	    (f -< a)   or   (f -<< a)
+--              Arrow application
+--          (f -< a)   or   (f -<< a)
 --
 --   D   |- fun :: a t1 t2
 --   D,G |- arg :: t1
@@ -198,16 +192,16 @@ tc_cmd env (HsCmdIf (Just fun) pred b1 b2) res_ty -- Rebindable syntax for if
 -- (plus -<< requires ArrowApply)
 
 tc_cmd env cmd@(HsCmdArrApp fun arg _ ho_app lr) (_, res_ty)
-  = addErrCtxt (cmdCtxt cmd)	$
+  = addErrCtxt (cmdCtxt cmd)    $
     do  { arg_ty <- newFlexiTyVarTy openTypeKind
-	; let fun_ty = mkCmdArrTy env arg_ty res_ty
-	; fun' <- select_arrow_scope (tcMonoExpr fun fun_ty)
+        ; let fun_ty = mkCmdArrTy env arg_ty res_ty
+        ; fun' <- select_arrow_scope (tcMonoExpr fun fun_ty)
              -- ToDo: There should be no need for the escapeArrowScope stuff
              -- See Note [Escaping the arrow scope] in TcRnTypes
 
-	; arg' <- tcMonoExpr arg arg_ty
+        ; arg' <- tcMonoExpr arg arg_ty
 
-	; return (HsCmdArrApp fun' arg' fun_ty ho_app lr) }
+        ; return (HsCmdArrApp fun' arg' fun_ty ho_app lr) }
   where
        -- Before type-checking f, use the environment of the enclosing
        -- proc for the (-<) case.  
@@ -218,7 +212,7 @@ tc_cmd env cmd@(HsCmdArrApp fun arg _ ho_app lr) (_, res_ty)
         HsFirstOrderApp  -> escapeArrowScope tc
 
 -------------------------------------------
--- 		Command application
+--              Command application
 --
 -- D,G |-  exp : t
 -- D;G |-a cmd : (t,stk) --> res
@@ -226,14 +220,14 @@ tc_cmd env cmd@(HsCmdArrApp fun arg _ ho_app lr) (_, res_ty)
 -- D;G |-a cmd exp : stk --> res
 
 tc_cmd env cmd@(HsCmdApp fun arg) (cmd_stk, res_ty)
-  = addErrCtxt (cmdCtxt cmd)	$
+  = addErrCtxt (cmdCtxt cmd)    $
     do  { arg_ty <- newFlexiTyVarTy openTypeKind
-	; fun'   <- tcCmd env fun (mkPairTy arg_ty cmd_stk, res_ty)
-	; arg'   <- tcMonoExpr arg arg_ty
-	; return (HsCmdApp fun' arg') }
+        ; fun'   <- tcCmd env fun (mkPairTy arg_ty cmd_stk, res_ty)
+        ; arg'   <- tcMonoExpr arg arg_ty
+        ; return (HsCmdApp fun' arg') }
 
 -------------------------------------------
--- 		Lambda
+--              Lambda
 --
 -- D;G,x:t |-a cmd : stk --> res
 -- ------------------------------
@@ -242,60 +236,60 @@ tc_cmd env cmd@(HsCmdApp fun arg) (cmd_stk, res_ty)
 tc_cmd env 
        (HsCmdLam (MG { mg_alts = [L mtch_loc (match@(Match pats _maybe_rhs_sig grhss))] }))
        (cmd_stk, res_ty)
-  = addErrCtxt (pprMatchInCtxt match_ctxt match)	$
-    do	{ (co, arg_tys, cmd_stk') <- matchExpectedCmdArgs n_pats cmd_stk
+  = addErrCtxt (pprMatchInCtxt match_ctxt match)        $
+    do  { (co, arg_tys, cmd_stk') <- matchExpectedCmdArgs n_pats cmd_stk
 
-		-- Check the patterns, and the GRHSs inside
-	; (pats', grhss') <- setSrcSpan mtch_loc		$
+                -- Check the patterns, and the GRHSs inside
+        ; (pats', grhss') <- setSrcSpan mtch_loc                $
                              tcPats LambdaExpr pats arg_tys     $
                              tc_grhss grhss cmd_stk' res_ty
 
-	; let match' = L mtch_loc (Match pats' Nothing grhss')
+        ; let match' = L mtch_loc (Match pats' Nothing grhss')
               arg_tys = map hsLPatType pats'
               cmd' = HsCmdLam (MG { mg_alts = [match'], mg_arg_tys = arg_tys
                                   , mg_res_ty = res_ty })
-	; return (mkHsCmdCast co cmd') }
+        ; return (mkHsCmdCast co cmd') }
   where
     n_pats     = length pats
-    match_ctxt = (LambdaExpr :: HsMatchContext Name)	-- Maybe KappaExpr?
+    match_ctxt = (LambdaExpr :: HsMatchContext Name)    -- Maybe KappaExpr?
     pg_ctxt    = PatGuard match_ctxt
 
     tc_grhss (GRHSs grhss binds) stk_ty res_ty
-	= do { (binds', grhss') <- tcLocalBinds binds $
-				   mapM (wrapLocM (tc_grhs stk_ty res_ty)) grhss
-	     ; return (GRHSs grhss' binds') }
+        = do { (binds', grhss') <- tcLocalBinds binds $
+                                   mapM (wrapLocM (tc_grhs stk_ty res_ty)) grhss
+             ; return (GRHSs grhss' binds') }
 
     tc_grhs stk_ty res_ty (GRHS guards body)
-	= do { (guards', rhs') <- tcStmtsAndThen pg_ctxt tcGuardStmt guards res_ty $
-				  \ res_ty -> tcCmd env body (stk_ty, res_ty)
-	     ; return (GRHS guards' rhs') }
+        = do { (guards', rhs') <- tcStmtsAndThen pg_ctxt tcGuardStmt guards res_ty $
+                                  \ res_ty -> tcCmd env body (stk_ty, res_ty)
+             ; return (GRHS guards' rhs') }
 
 -------------------------------------------
--- 		Do notation
+--              Do notation
 
 tc_cmd env (HsCmdDo stmts _) (cmd_stk, res_ty)
-  = do 	{ co <- unifyType unitTy cmd_stk  -- Expecting empty argument stack
-	; stmts' <- tcStmts ArrowExpr (tcArrDoStmt env) stmts res_ty 
-	; return (mkHsCmdCast co (HsCmdDo stmts' res_ty)) }
+  = do  { co <- unifyType unitTy cmd_stk  -- Expecting empty argument stack
+        ; stmts' <- tcStmts ArrowExpr (tcArrDoStmt env) stmts res_ty 
+        ; return (mkHsCmdCast co (HsCmdDo stmts' res_ty)) }
 
 
 -----------------------------------------------------------------
---	Arrow ``forms''	      (| e c1 .. cn |)
+--      Arrow ``forms''       (| e c1 .. cn |)
 --
---	D; G |-a1 c1 : stk1 --> r1
---	...
---	D; G |-an cn : stkn --> rn
---	D |-  e :: forall e. a1 (e, stk1) t1
+--      D; G |-a1 c1 : stk1 --> r1
+--      ...
+--      D; G |-an cn : stkn --> rn
+--      D |-  e :: forall e. a1 (e, stk1) t1
 --                                ...
 --                        -> an (e, stkn) tn
 --                        -> a  (e, stk) t
---	e \not\in (stk, stk1, ..., stkm, t, t1, ..., tn)
---	----------------------------------------------
---	D; G |-a  (| e c1 ... cn |)  :  stk --> t
+--      e \not\in (stk, stk1, ..., stkm, t, t1, ..., tn)
+--      ----------------------------------------------
+--      D; G |-a  (| e c1 ... cn |)  :  stk --> t
 
-tc_cmd env cmd@(HsCmdArrForm expr fixity cmd_args) (cmd_stk, res_ty)	
-  = addErrCtxt (cmdCtxt cmd)	$
-    do	{ (cmd_args', cmd_tys) <- mapAndUnzipM tc_cmd_arg cmd_args
+tc_cmd env cmd@(HsCmdArrForm expr fixity cmd_args) (cmd_stk, res_ty)    
+  = addErrCtxt (cmdCtxt cmd)    $
+    do  { (cmd_args', cmd_tys) <- mapAndUnzipM tc_cmd_arg cmd_args
         ; let e_ty = mkForAllTy alphaTyVar $   -- We use alphaTyVar for 'w'
                      mkFunTys cmd_tys $
                      mkCmdArrTy env (mkPairTy alphaTy cmd_stk) res_ty
@@ -306,19 +300,19 @@ tc_cmd env cmd@(HsCmdArrForm expr fixity cmd_args) (cmd_stk, res_ty)
     tc_cmd_arg :: LHsCmdTop Name -> TcM (LHsCmdTop TcId, TcType)
     tc_cmd_arg cmd
        = do { arr_ty <- newFlexiTyVarTy arrowTyConKind
-	    ; stk_ty <- newFlexiTyVarTy liftedTypeKind
-	    ; res_ty <- newFlexiTyVarTy liftedTypeKind
-	    ; let env' = env { cmd_arr = arr_ty }
-	    ; cmd' <- tcCmdTop env' cmd (stk_ty, res_ty)
-	    ; return (cmd',  mkCmdArrTy env' (mkPairTy alphaTy stk_ty) res_ty) }
+            ; stk_ty <- newFlexiTyVarTy liftedTypeKind
+            ; res_ty <- newFlexiTyVarTy liftedTypeKind
+            ; let env' = env { cmd_arr = arr_ty }
+            ; cmd' <- tcCmdTop env' cmd (stk_ty, res_ty)
+            ; return (cmd',  mkCmdArrTy env' (mkPairTy alphaTy stk_ty) res_ty) }
 
 -----------------------------------------------------------------
---		Base case for illegal commands
+--              Base case for illegal commands
 -- This is where expressions that aren't commands get rejected
 
 tc_cmd _ cmd _
   = failWithTc (vcat [ptext (sLit "The expression"), nest 2 (ppr cmd), 
-		      ptext (sLit "was found where an arrow command was expected")])
+                      ptext (sLit "was found where an arrow command was expected")])
 
 
 matchExpectedCmdArgs :: Arity -> TcType -> TcM (TcCoercion, [TcType], TcType)
@@ -332,34 +326,34 @@ matchExpectedCmdArgs n ty
 
 
 %************************************************************************
-%*									*
-		Stmts
-%*									*
+%*                                                                      *
+                Stmts
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 --------------------------------
---	Mdo-notation
+--      Mdo-notation
 -- The distinctive features here are
---	(a) RecStmts, and
---	(b) no rebindable syntax
+--      (a) RecStmts, and
+--      (b) no rebindable syntax
 
 tcArrDoStmt :: CmdEnv -> TcCmdStmtChecker
 tcArrDoStmt env _ (LastStmt rhs _) res_ty thing_inside
-  = do	{ rhs' <- tcCmd env rhs (unitTy, res_ty)
-	; thing <- thing_inside (panic "tcArrDoStmt")
-	; return (LastStmt rhs' noSyntaxExpr, thing) }
+  = do  { rhs' <- tcCmd env rhs (unitTy, res_ty)
+        ; thing <- thing_inside (panic "tcArrDoStmt")
+        ; return (LastStmt rhs' noSyntaxExpr, thing) }
 
 tcArrDoStmt env _ (BodyStmt rhs _ _ _) res_ty thing_inside
-  = do	{ (rhs', elt_ty) <- tc_arr_rhs env rhs
-	; thing 	 <- thing_inside res_ty
-	; return (BodyStmt rhs' noSyntaxExpr noSyntaxExpr elt_ty, thing) }
+  = do  { (rhs', elt_ty) <- tc_arr_rhs env rhs
+        ; thing          <- thing_inside res_ty
+        ; return (BodyStmt rhs' noSyntaxExpr noSyntaxExpr elt_ty, thing) }
 
 tcArrDoStmt env ctxt (BindStmt pat rhs _ _) res_ty thing_inside
-  = do	{ (rhs', pat_ty) <- tc_arr_rhs env rhs
-	; (pat', thing)  <- tcPat (StmtCtxt ctxt) pat pat_ty $
+  = do  { (rhs', pat_ty) <- tc_arr_rhs env rhs
+        ; (pat', thing)  <- tcPat (StmtCtxt ctxt) pat pat_ty $
                             thing_inside res_ty
-	; return (BindStmt pat' rhs' noSyntaxExpr noSyntaxExpr, thing) }
+        ; return (BindStmt pat' rhs' noSyntaxExpr noSyntaxExpr, thing) }
 
 tcArrDoStmt env ctxt (RecStmt { recS_stmts = stmts, recS_later_ids = later_names
                             , recS_rec_ids = rec_names }) res_ty thing_inside
@@ -368,15 +362,15 @@ tcArrDoStmt env ctxt (RecStmt { recS_stmts = stmts, recS_later_ids = later_names
         ; let tup_ids = zipWith mkLocalId tup_names tup_elt_tys
         ; tcExtendIdEnv tup_ids $ do
         { (stmts', tup_rets)
-		<- tcStmtsAndThen ctxt (tcArrDoStmt env) stmts res_ty	$ \ _res_ty' ->
-			-- ToDo: res_ty not really right
+                <- tcStmtsAndThen ctxt (tcArrDoStmt env) stmts res_ty   $ \ _res_ty' ->
+                        -- ToDo: res_ty not really right
                    zipWithM tcCheckId tup_names tup_elt_tys
 
         ; thing <- thing_inside res_ty
-		-- NB:	The rec_ids for the recursive things 
-		-- 	already scope over this part. This binding may shadow
-		--	some of them with polymorphic things with the same Name
-		--	(see note [RecStmt] in HsExpr)
+                -- NB:  The rec_ids for the recursive things 
+                --      already scope over this part. This binding may shadow
+                --      some of them with polymorphic things with the same Name
+                --      (see note [RecStmt] in HsExpr)
 
         ; let rec_ids = takeList rec_names tup_ids
         ; later_ids <- tcLookupLocalIds later_names
@@ -389,22 +383,22 @@ tcArrDoStmt env ctxt (RecStmt { recS_stmts = stmts, recS_later_ids = later_names
                                , recS_later_rets = later_rets
                                , recS_rec_ids = rec_ids, recS_rec_rets = rec_rets
                                , recS_ret_ty = res_ty }, thing)
-	}}
+        }}
 
 tcArrDoStmt _ _ stmt _ _
   = pprPanic "tcArrDoStmt: unexpected Stmt" (ppr stmt)
 
 tc_arr_rhs :: CmdEnv -> LHsCmd Name -> TcM (LHsCmd TcId, TcType)
 tc_arr_rhs env rhs = do { ty <- newFlexiTyVarTy liftedTypeKind
-		        ; rhs' <- tcCmd env rhs (unitTy, ty)
-		        ; return (rhs', ty) }
+                        ; rhs' <- tcCmd env rhs (unitTy, ty)
+                        ; return (rhs', ty) }
 \end{code}
 
 
 %************************************************************************
-%*									*
-		Helpers
-%*									*
+%*                                                                      *
+                Helpers
+%*                                                                      *
 %************************************************************************
 
 
@@ -412,15 +406,15 @@ tc_arr_rhs env rhs = do { ty <- newFlexiTyVarTy liftedTypeKind
 mkPairTy :: Type -> Type -> Type
 mkPairTy t1 t2 = mkTyConApp pairTyCon [t1,t2]
 
-arrowTyConKind :: Kind		--  *->*->*
+arrowTyConKind :: Kind          --  *->*->*
 arrowTyConKind = mkArrowKinds [liftedTypeKind, liftedTypeKind] liftedTypeKind
 \end{code}
 
 
 %************************************************************************
-%*									*
-		Errors
-%*									*
+%*                                                                      *
+                Errors
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
diff --git a/compiler/typecheck/TcCanonical.lhs b/compiler/typecheck/TcCanonical.lhs
index 2aae1d1..8166ad0 100644
--- a/compiler/typecheck/TcCanonical.lhs
+++ b/compiler/typecheck/TcCanonical.lhs
@@ -1,10 +1,4 @@
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module TcCanonical(
     canonicalize, emitWorkNC,
@@ -517,13 +511,13 @@ flatten loc f ctxt (TyConApp tc tys)
   -- flatten it away as well, and generate a new given equality constraint
   -- between the application and a newly generated flattening skolem variable.
   | otherwise
-  = ASSERT( tyConArity tc <= length tys )	-- Type functions are saturated
+  = ASSERT( tyConArity tc <= length tys )       -- Type functions are saturated
       do { (xis, cos) <- flattenMany loc f ctxt tys
          ; let (xi_args,  xi_rest)  = splitAt (tyConArity tc) xis
                (cos_args, cos_rest) = splitAt (tyConArity tc) cos
-	       	 -- The type function might be *over* saturated
-		 -- in which case the remaining arguments should
-		 -- be dealt with by AppTys
+                 -- The type function might be *over* saturated
+                 -- in which case the remaining arguments should
+                 -- be dealt with by AppTys
                fam_ty = mkTyConApp tc xi_args
                
          ; (ret_co, rhs_xi) <-
@@ -604,7 +598,7 @@ flattenTyVar, flattenFinalTyVar
 -- for the unification variables that have been unified already with the inert
 -- equalities, see Note [Spontaneously solved in TyBinds] in TcInteract.
 flattenTyVar loc f ctxt tv
-  | not (isTcTyVar tv)	              -- Happens when flatten under a (forall a. ty)
+  | not (isTcTyVar tv)                -- Happens when flatten under a (forall a. ty)
   = flattenFinalTyVar loc f ctxt tv   -- So ty contains referneces to the non-TcTyVar a
   | otherwise
   = do { mb_ty <- isFilledMetaTyVar_maybe tv
@@ -712,8 +706,8 @@ emitWorkNC loc evs
 canEqNC :: CtLoc -> CtEvidence -> Type -> Type -> TcS StopOrContinue
 
 canEqNC _loc ev ty1 ty2
-  | eqType ty1 ty2	-- Dealing with equality here avoids
-    	     	 	-- later spurious occurs checks for a~a
+  | eqType ty1 ty2      -- Dealing with equality here avoids
+                        -- later spurious occurs checks for a~a
   = if isWanted ev then
       setEvBind (ctev_evar ev) (EvCoercion (mkTcReflCo ty1)) >> return Stop
     else
@@ -783,11 +777,11 @@ canEqNC loc ev ty1 ty2
       | Just (s1,t1) <- tcSplitAppTy_maybe ty1
       , Just (s2,t2) <- tcSplitAppTy_maybe ty2
       = do { let xevcomp [x,y] = EvCoercion (mkTcAppCo (evTermCoercion x) (evTermCoercion y))
-             	 xevcomp _ = error "canEqAppTy: can't happen" -- Can't happen
-             	 xevdecomp x = let xco = evTermCoercion x 
-       	                       in [EvCoercion (mkTcLRCo CLeft xco), EvCoercion (mkTcLRCo CRight xco)]
-       	   ; ctevs <- xCtFlavor ev [mkTcEqPred s1 s2, mkTcEqPred t1 t2] (XEvTerm xevcomp xevdecomp)
-       	   ; canEvVarsCreated loc ctevs }
+                 xevcomp _ = error "canEqAppTy: can't happen" -- Can't happen
+                 xevdecomp x = let xco = evTermCoercion x 
+                               in [EvCoercion (mkTcLRCo CLeft xco), EvCoercion (mkTcLRCo CRight xco)]
+           ; ctevs <- xCtFlavor ev [mkTcEqPred s1 s2, mkTcEqPred t1 t2] (XEvTerm xevcomp xevdecomp)
+           ; canEvVarsCreated loc ctevs }
 
       | otherwise
       = do { emitInsoluble (CNonCanonical { cc_ev = ev, cc_loc = loc })
@@ -995,14 +989,14 @@ classify (TyConApp tc tys) | isSynFamilyTyCon tc
                            , tyConArity tc == length tys
                            = FunCls tc tys
 classify ty                | Just ty' <- tcView ty
-	                   = case classify ty' of
+                           = case classify ty' of
                                OtherCls {} -> OtherCls ty
                                var_or_fn   -> var_or_fn
                            | otherwise 
                            = OtherCls ty
 
 -- See note [Canonical ordering for equality constraints].
-reOrient :: TypeClassifier -> TypeClassifier -> Bool	
+reOrient :: TypeClassifier -> TypeClassifier -> Bool    
 -- (t1 `reOrient` t2) responds True 
 --   iff we should flip to (t2~t1)
 -- We try to say False if possible, to minimise evidence generation
